event_block_tiles:
	.db 10
	.dw event_down_cliff
	.db 11
	.dw event_right_cliff
	.db 12
	.dw event_left_cliff

event_block_tiles_end:

event_tiles:
	.db 3
	.dw event_grass
	.db 18
	.dw event_door

event_tiles_end:

event_down_cliff:
	ld hl,(player_direction)
	ld de,player_down
	call cp_hl_de
	ret nz
	call walk_down_no_collision
	jp walk_down_no_collision

event_right_cliff:
	ld hl,(player_direction)
	ld de,(player_right)
	call cp_hl_de
	ret nz
	call walk_right_no_collision
	jp walk_right_no_collision

event_left_cliff:
	ld hl,(player_direction)
	ld de,(player_left)
	call cp_hl_de
	ret nz
	call walk_left_no_collision
	jp walk_left_no_collision

event_grass:
	ld b,pokemon_encounter_frequency
	call ionRandom
	or a
	ret nz
	ld b,2
	call flash_screen
	call fade_out
	jr battle

event_door:
	ld b,2
	jp flash_screen