calculate_proportionality:	; output : a = int((hl/hl+1)*a)
	push af
	push hl
	ld l,(hl)
	ld h,0
	bcall _setxxxxop2
	bcall _op2toop1
	pop hl
	inc hl
	ld l,(hl)
	ld h,0
	bcall _setxxxxop2
	bcall _fpdiv
	pop af
	bcall _setxxop2
	bcall _fpmult
	bcall _int
	bcall _convop1
	ret

calculate_damages:	; output : a = int((((hl+1*0.4+2)*[attack_power])*(hl+(pokemon_att-pokemon_stats))/(de+(pokemon_def-pokemon_lvl))*50+2)*CE)
	push hl
	ld h,0
	ld l,opponent_pokemon_stats_def-opponent_pokemon_stats
	add hl,de
	ld l,(hl)	; on a DEF
	ld h,0
	bcall _setxxxxop2
	ld a,50
	bcall _setxxop1
	bcall _fpmult
	bcall _op1toop4
	ld a,2
	bcall _setxxop1
	ld a,5
	bcall _setxxop2
	bcall _fpdiv
	pop hl
	push hl
	inc hl	; son niveau
	ld l,(hl)
	ld h,0
	bcall _setxxxxop2
	bcall _fpmult
	ld a,2
	bcall _setxxop2
	bcall _fpadd
	pop hl
	ld d,0
	ld e,pokemon_att-pokemon_stats
	add hl,de
	ld l,(hl)	; on a ATT
	ld h,0
	bcall _setxxxxop2
	bcall _fpmult
	ld a,(current_attack)
	call find_attack_a
	ld d,0
	ld e,attack_power-attack_data
	add hl,de
	ld l,(hl)
	ld h,d
	bcall _setxxxxop2
	bcall _fpmult
	bcall _op4toop2
	bcall _fpdiv
	ld a,2
	bcall _setxxop2
	bcall _fpadd
CE = $+1	; 0=pas trs efficace, 1=normal, 2=super efficace
	ld a,0
	or a
	jr z,calculate_damages_not_effective
	bcall _setxxop2
	bcall _fpmult
	jr calculate_damages_next

calculate_damages_not_effective:
	ld a,2
	bcall _setxxop2
	bcall _fpdiv

calculate_damages_next:
	bcall _int
	bcall _convop1
	; rajouter la marge d'erreur de 15% (0.85  1 fois le rsultat)
	ret

; cf http://www.pokepedia.fr/index.php/Calcul_des_statistiques , je modifierai peut tre la formule ci-dessous :
calculate_hp:	; output : a = int(2*hl*a/100+a+10)
	call calculate_stats_or_hp
	ld h,0
	ld l,a
	bcall _setxxxxop2
	bcall _fpadd
	ld a,10
	jr calculate_stats_or_hp_end

calculate_stats:	; output : a = int(2*hl*a/100+5)
	call calculate_stats_or_hp
	ld a,5

calculate_stats_or_hp_end:
	bcall _setxxop2
	bcall _fpadd
	bcall _int
	bcall _convop1
	ret

calculate_stats_or_hp:
	push af
	push hl
	ld a,2
	bcall _setxxop1
	pop hl
	ld l,(hl)
	ld h,0
	bcall _setxxxxop2
	bcall _fpmult
	pop af
	push af
	ld h,0
	ld l,a
	bcall _setxxxxop2
	bcall _fpmult
	ld a,100
	bcall _setxxxxop2
	bcall _fpdiv
	pop af
	ret